//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "cy7c63001.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
       // Handle ermitteln
       hTreiber = CreateFile( "\\\\.\\Thermometer_0",
                    GENERIC_WRITE,
                    FILE_SHARE_WRITE,
                    NULL,
                    OPEN_EXISTING,
                    0,
                    0 );

       // Zeiger nitialisieren
       pIn = &szIn[0];
       pOut = &szOut[0];
       lpByte = &lByte;

       // Anzeige setzen
       Label1->Caption = "---C";

       // Fensterposition setzen
       Form1->Top = 100;
       Form1->Left = 100;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormDestroy(TObject *Sender)
{
        CloseHandle( hTreiber );
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
        Timer1->Enabled = false;
        LeseTemp();
        LeseS1();
        Timer1->Enabled = true;
}
//---------------------------------------------------------------------------
// Temperatur auslesen
void TForm1::LeseTemp( void )
{
        int nTemp;
        AnsiString sTemp;

        // 0x04 = Control-Code; Funktionsnummer
        // szOut[0] = Status; [1] = Temperatur; [2] = Vorzeichen; [3] = Schalter
        szIn[0] = 0x0b;

        DeviceIoControl( hTreiber, 0x04, pIn, sizeof(szIn), pOut,
                        sizeof(szOut), lpByte, NULL );

         // Temperatur ermitteln
         nTemp = szOut[1]/2;

        // Ausgabe zusammensetzen
        if ( szOut[2] == 0 ) sTemp += "+";
        else sTemp += "-";
        sTemp += nTemp;
        sTemp += "C";
        Label1->Caption = sTemp;
}
//---------------------------------------------------------------------------
// Helligkeit der LED D2 einstellen
void __fastcall TForm1::TrackBar1Change(TObject *Sender)
{
        Timer1->Enabled = false;

        // Setze LED Helligkeit
        szIn[0] = 0x0e;
        szIn[1] = (char)TrackBar1->Position;

        DeviceIoControl( hTreiber, 0x04, pIn, sizeof(szIn), pOut,
                        sizeof(szOut), lpByte, NULL );

        Timer1->Enabled = true;                        
}

//---------------------------------------------------------------------------
// Lese Port 1 lesen uns S1 auskodieren
void TForm1::LeseS1( void )
{
        szIn[0] = 0x14; // Lese Port
        szIn[1] = 0x1;  // Port 1 auslesen

        DeviceIoControl( hTreiber, 0x04, pIn, sizeof(szIn), pOut,
                        sizeof(szOut), lpByte, NULL );

        // Schalter 1 offen
        if ( (szOut[1] & 0x04) == 0x4 )
        {
                Shape1->Brush->Color = clAqua;
                Label3->Caption = "S1 offen";
        }
        // Schalter 1 geschlossen
        else
        {
                Shape1->Brush->Color = clBtnFace;
                Label3->Caption = "S1 geschlossen";
        }
}
